/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.cpp																			  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "MainWindow.h"
#include "Game.h"

Game::Game( MainWindow& wnd )
	:
	wnd( wnd ),
	gfx( wnd )
{
}

void Game::Go()
{
	gfx.BeginFrame();	
	UpdateModel();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::UpdateModel()
{
	b = 255; c = 255; vel = 5;
	if (wnd.kbd.KeyIsPressed(VK_SHIFT)) { a = 255; b = 0; c = 0; vel = 3; }
	if (wnd.kbd.KeyIsPressed(VK_UP)) { y -= vel; }
	if (wnd.kbd.KeyIsPressed(VK_DOWN)) { y += vel; }
	if (wnd.kbd.KeyIsPressed(VK_LEFT)) { x -= vel; }
	if (wnd.kbd.KeyIsPressed(VK_RIGHT)) { x += vel; }
	shapeIsChanged = wnd.kbd.KeyIsPressed(0x5A);
}

void Game::ComposeFrame()
{	
	if (shapeIsChanged) {
		gfx.PutPixel(x + 3, y+3, a, b, c);
		gfx.PutPixel(x + 2, y+2, a, b, c);
		gfx.PutPixel(x + 1, y+1, a, b, c);

		gfx.PutPixel(x - 1, y-1, a, b, c);
		gfx.PutPixel(x - 2, y-2, a, b, c);
		gfx.PutPixel(x - 3, y-3, a, b, c);

		gfx.PutPixel(x+1, y - 1, a, b, c);
		gfx.PutPixel(x+2, y - 2, a, b, c);
		gfx.PutPixel(x+3, y - 3, a, b, c);

		gfx.PutPixel(x-1, y + 1, a, b, c);
		gfx.PutPixel(x-2, y + 2, a, b, c);
		gfx.PutPixel(x-3, y + 3, a, b, c);
	}
	else {
		gfx.PutPixel(x + 3, y, a, b, c);
		gfx.PutPixel(x + 2, y, a, b, c);
		gfx.PutPixel(x + 1, y, a, b, c);

		gfx.PutPixel(x - 1, y, a, b, c);
		gfx.PutPixel(x - 2, y, a, b, c);
		gfx.PutPixel(x - 3, y, a, b, c);

		gfx.PutPixel(x, y - 1, a, b, c);
		gfx.PutPixel(x, y - 2, a, b, c);
		gfx.PutPixel(x, y - 3, a, b, c);

		gfx.PutPixel(x, y + 1, a, b, c);
		gfx.PutPixel(x, y + 2, a, b, c);
		gfx.PutPixel(x, y + 3, a, b, c);
	}

}
